"""
* SHEP self learning AI code
* 
* Written by Dexter R C Shepherd, Aged 19
* shepai.github.io
*
* Uses SHEP library 2020
* V0.0.9
"""

########################################################################
import nltk
import sqlite3
from difflib import SequenceMatcher
import sys
from itertools import permutations
import re
import os
import json
import sys
import json
import datetime
from random import randrange, choice
#graph machine learning
class Queue:
    #queue data structure 
    def __init__(self):
        self.data=[]
    def push(self,item):
        self.data.append(item)
    def pop(self):
        item = self.data[0]
        del self.data[0]
        return item
    def size(self):
        return len(self.data)
class Edge:
    def __init__(self,vertex1,vertex2):
        self.name=""
        self.vertices=[vertex1,vertex2]
        self.strength=0
        self.weight=0

class fileStructure:
        #python dictionary structure but saves all data and stores it in drive and not RAM
        def __init__(self,filepath):
            if not os.path.isdir(filepath+"DictionaryFolder/"):
                os.makedirs(filepath+"DictionaryFolder/")
            self.filepath=filepath+"DictionaryFolder/"
            if not os.path.exists(filepath+"DictionaryFolder/index.txt"):
                file=open(filepath+"DictionaryFolder/index.txt","w")
                file.close()
        def readFolder(self,vertex,path):
            nodes=[]
            for subdir, dirs, files in os.walk(path):
                for file in files:
                    f=open(path+file,"r")
                    r=f.read()
                    f.close()
                    stats=r.split(":::") #read data in file
                    e=Edge(vertex,stats[3]) #form edge
                    e.name=stats[2]
                    e.strength=stats[0]
                    e.weight=stats[1]
                    nodes.append(e)
            return nodes
        def writeFolder(self,folder,nodes):
            for edge in nodes: #write each edge to files
                found=False
                count=0
                while found==False:
                    try:
                        file=open(folder+str(edge).replace("<","").replace(">","")+str(count)+".txt","r")
                        count+=1
                    except:
                        found=True
                file=open(folder+str(edge).replace("<","").replace(">","")+str(count)+".txt","w")
                file.write(str(edge.strength)+":::"+str(edge.weight)+":::"+edge.name+":::"+edge.vertices[1])
                file.close()
        def __repr__(self):
            nodes=[]
            for subdir, dirs, files in os.walk(self.filepath):
                for i in dirs:
                    nodes.append(i)
            return nodes
        def __str__(self):
            nodes=[]
            for subdir, dirs, files in os.walk(self.filepath):
                for i in dirs:
                    nodes.append(i)
            return str(nodes)
        def __getitem__(self,value): #get value
            if value==0: #called upon in different way
                for subdir, dirs, files in os.walk(self.filepath):
                    return dirs
            f=open(self.filepath+"index.txt", encoding = "ISO-8859-1")
            for line in f:
                line=line.replace("\n","")
                vals=line.split(",")
                if vals[0]==value:
                        return self.readFolder(value,self.filepath+vals[1]+"/")
            raise KeyError(str(value)+" -- "+"Item not found in structure") #return an error
        def __setitem__(self,value,setTo): #set value
            num=-1
            count=0
            f=open(self.filepath+"index.txt", encoding = "ISO-8859-1")
            for line in f:
                count+=1
                line=line.replace("\n","")
                vals=line.split(",")
                if vals[0]==value:
                    num=int(vals[1])
                    for subdir, dirs, files in os.walk(self.filepath+vals[1]+"/"):
                        for z in files:
                                os.remove(self.filepath+vals[1]+"/"+z)
                        os.rmdir(self.filepath+vals[1]+"/")
                        break
            if num==-1:
                num=count+1 #create number
                slashn="\n"
                f=open(self.filepath+"index.txt","a") #add to index file
                f.write(value+","+str(num)+slashn)
                f.close()
            os.makedirs(self.filepath+str(num)+"/")
            self.writeFolder(self.filepath+str(num)+"/",setTo) #write to the folder
        def __len__(self):
            #return the length of the data stored
            for subdir, dirs, files in os.walk(self.filepath):
                return len(dirs)
class Graph:
    #graph data structure for associative learning
    #only change from other graph is that the show function does not work
    def __init__(self,filepath):
        self.data=fileStructure(filepath)
    def addDirected(self,edge):
        #add data
        try:
            val=self.data[edge.vertices[0]]
            changes=False
            for i in range(len(val)):
                #print(edge.vertices[0],val[i].vertices[1],edge.vertices[1])
                if val[i].vertices[1]==edge.vertices[1]: #if found increase strength connection
                    val[i].strength+=1
                    changes=True
            if changes==False: #if not yet in
               val.append(edge) #add
               self.data[edge.vertices[0]]=val #set data
               try: #check if real
                   val=self.data[edge.vertices[1]]
               except:
                    self.data[edge.vertices[1]]=[] #add node with no connections
            else:
                self.data[edge.vertices[0]]=val
        except:
            self.data[edge.vertices[0]]=[edge] #add node with no connections
            try:
                val=self.data[edge.vertices[1]] #check exists
            except:
                self.data[edge.vertices[1]]=[] #create empty
    def addUndirected(self,edge):
        #add data undirected (so for both nodes)
        self.addDirected(edge) #add edge
        edge=self.getEdge(edge.vertices[0],edge.vertices[1]) #get new connetion
        vertices=edge.vertices #reverse edge connection
        strength=edge.strength
        edge=Edge(vertices[1],vertices[0]) #new edge to not confuse with old memory
        edge.strength=strength
        self.addDirected(edge) #add edge 
    def show(self):
        for i in self.data[0]:
            print(i)
            for j in self.data[i]:
                print(j.vertices,j.strength)
    def delete(self,vertex):
        try:
            cons=self.getConnected(vertex)
            for i in cons: #remove each connection to if undirected
                current=self.data[i.vertices[1]]
                while vertex in current: #delete where it appears
                    del current[current.index(vertex)]
            return self.data.pop(vertex, None) #finally remove
        except: #nothing in the data
            return None
    def getConnected(self,vertex):
        #return all directly connected to the given vertex
        data=[]
        try:
            return self.data[vertex]
        except:
            return []
    def allReachable(self,vertex,offlimits):
        #Get a path to see if two points are reachable
        #uses breadth-first algorithm
        visited=[]
        q=Queue()
        q.push(vertex)
        visited.append(vertex)
        while q.size()>0:
            v=q.pop() #get the next connected item
            connections=self.getConnected(v)
            for i in connections:
                if i.vertices[1] not in visited and i.vertices[1] not in offlimits: #accurate
                    visited.append(i.vertices[1])
                    q.push(i.vertices[1])
        return visited
    def getEdge(self,vertex1,vertex2):
        for i in self.data[vertex1]:
            if i.vertices[1]==vertex2:
                return i
    def shortestRoute(self,start,end,offlimit):
        q=Queue()
        q.push(start)
        cameFrom={}
        cost={}
        cameFrom[start]=None
        cost[start]=0
        while q.size()>0: #sort paths 
            current=q.pop()
            if current == end:
                break
            for next in self.getConnected(current):
                new_cost=cost[current]+next.weight
                if next.vertices[1] not in offlimit:
                    if next.vertices[1] not in cost or new_cost<cost[next.vertices[1]]:
                        cost[next.vertices[1]]=new_cost
                        q.push(next.vertices[1])
                        cameFrom[next.vertices[1]]=current
        try:
            key=cameFrom[end]
        except: #error as it is not connected
            return None
        #find direct route
        cameFromKeys=list(reversed(sorted(cameFrom)))
        path=[]
        key=end
        path.append(key)
        while key!=start:
            key=cameFrom[key]
            path.append(key)
        return list(reversed(path))
    def strongest(self,vertex):
        connections=self.getConnected(vertex)
        if len(connections)>0:
            sum=0
            for i in connections:
                sum+=i.strength
            average=sum/len(connections)
            nodes=[]
            for i in connections:
                if i.strength>average:
                    nodes.append(i.vertices[1])
            return nodes
"""
* Artificial Intelligence chat bot framework
* Code developed by Dexter R Shepherd, aged 18
* Info found at shepai.github.io
* SHEP AI 2020 see license at: https://shepai.github.io/downloads/SHEP%20AI%202020%20License.txt
"""
class SpellEngine:
    #def __init__(self):
        #self.spell = SpellChecker()
    def getCorrected(self,sentence):
        sentence=sentence.replace("?",".").replace("!",".").replace(";",".") #split sentences
        #misspelled = self.spell.unknown(sentence.replace(".","").split())
        #for word in misspelled:
        #    # Get the one `most likely` answer
        #    correct=self.spell.correction(word)
        #    sentence=sentence.replace(word,correct)
        sentence=sentence.split(".")
        i=0
        while i<len(sentence): #delete empty
            if sentence[i]=="":
                del sentence[i]
                i-=1
            i+=1
        return sentence
class Language:
    def __init__(self,path):
        self.Sample_Questions = ["what is the weather like","where are we today","why did you do that","where is the dog","when are we going to leave","why do you hate me","what is the Answer to question 8",
                    "what is a dinosour","what do i do in an hour","why do we have to leave at 6.00", "When is the apointment","where did you go","why did you do that","how did he win","why wonÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬ ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬ ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬ÃƒÂ¢Ã¢â‚¬Å¾Ã‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬ ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¡ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬ ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¾ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢t you help me",
                    "when did he find you","how do you get it","who does all the shipping","where do you buy stuff","why donÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬ ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬ ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬ÃƒÂ¢Ã¢â‚¬Å¾Ã‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬ ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¡ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬ ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¾ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã…Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢t you just find it in the target","why don't you buy stuff at target","where did you say it was",
                    "when did he grab the phone","what happened at seven am","did you take my phone","do you like me","do you know what happened yesterday","did it break when it dropped","does it hurt everyday",
                    "does the car break down often","can you drive me home","where did you find me"
                    "can it fly from here to target","could you find it for me","hi","hello"
                    "can i join","can i eat candy","hi there","where can i get help","where is the best place"
                    "i was wondering if you could help me","could you tell me where i can find this","thank you"
                    "thanks","what mental health support is there","where can I find the treasure","what time does the theatre open and when does it close"
                    "how do i get in cheaper and how much"]
        try:
            file=open(path+"sentenceDemos.txt","r")
            r=file.read()
            file.close()
            self.Sample_Questions=r.split(":::")
            self.Sample_Questions=self.Sample_Questions[:-1]
        except: #create file
            file=open(path+"sentenceDemos.txt","w")
            for i in self.Sample_Questions:
                file.write(i+":::")
            file.close()
    def splitQuestion(self,sentence):
        tokens = nltk.word_tokenize(sentence) #tokenize sentence
        tagged = nltk.pos_tag(tokens) #get tags
        q=[]
        for i in tagged:
            if "W" == i[1][0] or "VBP" in i[1]:
                q.append(i[0])
        return q
    def splitSubjects(self,sentence):
        tokens = nltk.word_tokenize(sentence) #tokenize sentence
        tagged = nltk.pos_tag(tokens) #get tags
        s=[]
        for i in tagged:
            if "NN" in i[1] or "IN" in i[1] or "JJ" in i[1] or "VBG" in i[1] or "VB"==i[1]:
                s.append(i[0])
        return s
    def splitDirected(self,sentence):
        tokens = nltk.word_tokenize(sentence) #tokenize sentence
        tagged = nltk.pos_tag(tokens) #get tags
        s=[]
        for i in tagged:
            if "P" in i[1][:-1]:
                s.append(i[0])
        return s
    def splitMeaning(self,sentence):
        #split the sentence into the meaning phrases and return to become nodes
        tokens = nltk.word_tokenize(sentence) #tokenize sentence
        tagged = nltk.pos_tag(tokens) #get tags
        nodes=""
        sentences=[]
        for i in tagged:
            if "CC" in i[1]:
                sentences.append(nodes[:-1])
                nodes=""
            else:
                nodes+=i[0]+" "
        if nodes!="":
            sentences.append(nodes)
        return sentences
    def getType(self,sentence):
        for Ran_Question in self.Sample_Questions:
            Question_Matcher = SequenceMatcher(None, Ran_Question, sentence).ratio()
            if Question_Matcher > 0.5:
                        return "question"
        return "statement"
class dataBase:
    def __init__(self,name):
        self.name=name
        found=True
        try:
            file=open(name,"r")
            file.close()
        except: #check if database needs forming
            found=False
        try:
            self.conn = sqlite3.connect(name)
            self.cur=self.conn.cursor()
            if found==False: #if not yet created
                self.cur.execute("CREATE TABLE Data(id INT, question STRING, priority INT)") #store input row
                self.conn.commit()
        except (RuntimeError, TypeError, NameError) as e:
            raise e("Cannot connect to the database!")
        self.getPK()
    def getPK(self):
        self.cur.execute("SELECT * FROM Data")
        rows = self.cur.fetchall()
        self.PK=len(rows)+1
    def enterData(self,question):
        self.cur.execute("SELECT ID,priority FROM Data WHERE question=?",(question,))
        rows = self.cur.fetchall()
        p=0
        if len(rows)!=0:
            self.delete(question)
            p=rows[0][1]+1
        self.cur.execute('insert into Data values (?,?,?)',[self.PK,question,p])
        self.conn.commit()
        self.PK+=1
    def delete(self,question):
        self.cur.execute("DELETE FROM Data WHERE question=?",(question,))
        self.conn.commit()
    def increaseByID(self,ID):
        self.cur.execute("SELECT ID,question,priority FROM Data WHERE id=?",(ID,))
        rows = self.cur.fetchall()
        try:
            self.delete(rows[0][1])
            self.cur.execute('insert into Data values (?,?,?)',[ID,rows[0][1],rows[0][2]+1])
        except IndexError: #if error
            self.cur.execute("DELETE FROM Data WHERE ID=?",(rows[0][0],))
    def readData(self):
        self.cur.execute("SELECT * FROM Data")
        rows = self.cur.fetchall()
        return rows
    def containsLanguage(self,data):
        #find if the general saying is within the data:
        self.cur.execute("SELECT * FROM Data")
        rows = self.cur.fetchall()
        data=data.split()
        for i in rows:
            vals=i[1].split()
            if SequenceMatcher(None, vals, data).ratio()>0.9:
                return i[0]
        return None
class Bot:
    def __init__(self,ID,systemPathway):
        self.ID=ID #set an ID for the bot
        self.lang=Language(systemPathway) #Language analyzer
        self.Questions=Graph(systemPathway+"questions.json") #questions analyser
        self.Statements=dataBase(systemPathway+"Statements.db") #statements analyser
        self.systemPathway=systemPathway
        self.database=dataBase(systemPathway+"Confused.db")
        
    def similar(self,a, b):
        count=0
        for i in a:
            if i in b:
                count+=1
        count1=0
        for i in b:
            if i in a:
                count1+=1
        return (count+count1)/(len(a)+len(b))
        #return SequenceMatcher(None, a, b).ratio()
    def assignSim(self,tmp,subjects,AL):
        similarity=0
        if len([x for x in tmp if x in subjects])==len(subjects): #if both subjects present
                    similarity=AL+0.08
        else:
                    similarity=AL-0.2 #lower chance if subjects irrelevant
        return similarity
    def checkQuestion(self,nodes):
            #get the links to each question
            past=[]
            for i in nodes: #gather the subject responses
                vals=self.Questions.getConnected(i)
                tmp=[]
                for j in vals:
                    val=j.vertices[1]
                    if val not in past:
                        tmp.append(val)
                past+=tmp
            largest=0
            value=""
            questionLinks=[]
            for j in past: #find which answers best fit
                vals=self.Questions.getConnected(j)
                tmp=[]
                for i in vals:
                    val=i.vertices[1]
                    tmp.append(val)
                questionLinks.append([j,tmp])
            return questionLinks
    def splitLanguage(self,sentence):
        directedTo=self.lang.splitDirected(sentence)
        subjects=self.lang.splitSubjects(sentence)
        meaning=self.lang.splitQuestion(sentence)
        return directedTo,subjects,meaning
    def Enter(self,sentence,previous):
        #main query function which takes in a sentence and returns likely response
        Subsentences=self.lang.splitMeaning(sentence)
        GlobalSubjects=self.lang.splitSubjects(sentence)
        lineOfSubjects=""
        response=""
        self.potentials=[] #store all potential responses (>80%)
        self.sub_potentials=[] #store all sub potential responses (>50%)
        Subsentences=[sentence]+Subsentences #try as whole then proceed to split
        for i in Subsentences:
            type=self.lang.getType(i)
            directedTo=self.lang.splitDirected(i)
            subjects=self.lang.splitSubjects(i)
            meaning=self.lang.splitQuestion(i)
            if len(directedTo+subjects+meaning)<2 and subjects: #if small iconic sentence
                directedTo=[]
                meaning=[]
                subjects=i.split()
            if type=="question":
                largestChance,answer = self.find(meaning,directedTo,subjects) #find
                probability=largestChance
                self.findAll(meaning,directedTo,subjects) #find all or the extra data
                if probability >=0.8: #found
                    if Subsentences.index(i)>0:
                        response+=answer+". "
                    else:
                        response=answer
                        break
                elif probability >=0.5: #might have found
                    if Subsentences.index(i)==0:
                        response="This is something similar I found which may answer your question '"+answer+"'"
                        break
            elif type=="statement": #potentially scrap
                #add to statements for analyses of statements
                nodes = directedTo+subjects
                string=""
                for i in nodes: #convert to string
                        string+=i+" "
                        
                id=self.Statements.containsLanguage(string[:-1])
                if id==None:
                        self.Statements.enterData(string[:-1])
                else:
                        self.Statements.increaseByID(id)
                response="Thank you for your feedback"
            if response=="":
                self.database.enterData(sentence)
        return [response,lineOfSubjects]
    def find(self,meaning,directedTo,subjects):
                nodes = meaning+directedTo+subjects
                links=self.checkQuestion(nodes)
                largestChance=0
                answer=""
                foundNodes=[]
                for z in links:
                    ###purge old formats####
                    n=[]
                    for j in z[1]:
                        n+=j.replace("C:","").split()
                    probability=self.similar(n,nodes)
                    count=0
                    
                    for subject in subjects: #count if all subjects present
                        if subject in z[1]:
                            count+=1
                    if count==len(subjects): #all subjects present
                        probability+=0.08
                    else: #not all subjects are present
                        probability-=0.1
                    if probability>largestChance:
                        largestChance=probability
                        foundNodes=z[1]
                        answer=self.removeBrackets(z[0])
                return largestChance,answer
    def findAll(self,meaning,directedTo,subjects):
                nodes = meaning+directedTo+subjects
                links=self.checkQuestion(nodes)
                largestChance=0
                answer=""
                foundNodes=[]
                for z in links:
                    ###purge old formats####
                    n=[]
                    for j in z[1]:
                        n+=j.replace("C:","").split()
                    probability=self.similar(n,nodes)
                    count=0
                    
                    for subject in subjects: #count if all subjects present
                        if subject in z[1]:
                            count+=1
                    if count==len(subjects): #all subjects present
                        probability+=0.08
                    else: #not all subjects are present
                        probability-=0.1
                    if probability>0.8:
                        self.potentials.append(self.removeBrackets(z[0]))
    def removeBrackets(self,string):
        string=re.sub('\[.*?\]', "", string)
        return string.replace("[]","")
class botClient:
    #built to use less memory and provide an interface with the main bot
    #responsible for interacting
    def __init__(self,bot):
        self.bot=bot
        self.SC=SpellEngine() #deploy the spell check engine
    def Enter(self,userInput,subjects):
        if userInput!="":
            sentences=self.SC.getCorrected(userInput)
            responses=""
            for i in sentences:
                returned=self.bot.Enter(i,subjects)
                responses+=returned[0]+"$"
                subjects=returned[1]
            responses=responses.replace("..",".")
            responses=responses.replace(". .",".")
            if responses.replace("$","")=="":
                responses="Sorry, I am not sure on that yet. Maybe ask again another time and you will get your answer"
            string=""
            for i in subjects:
                string+=i+","
            return [responses,string[:-1]]
        return ""
    def add(self,question,answer):
        question=question.lower()
        if self.bot.Questions.getConnected(answer) !=[]: #cannot have same answer twice
            count=0
            while True: #loop testing out names
                if self.bot.Questions.getConnected(answer+"["+str(count)+"]") ==[]:
                    answer=answer+"["+str(count)+"]"
                    break
                count+=1
        v1=self.bot.lang.splitQuestion(question) #get nodes
        v1+=self.bot.lang.splitSubjects(question) #get nodes
        v1+=self.bot.lang.splitDirected(question) #get nodes
        for i in range(3): #add three times
            for i in v1:
                self.bot.Questions.addDirected(Edge(i,answer)) #add to graph
                self.bot.Questions.addDirected(Edge(answer,i)) #add to graph
        #SaveMemory(self.bot.systemPathway+"questions.json",self.bot.Questions.data) #save to file
        
    def feedback(self,type,sentence):
        if type=="negative":
            self.bot.database.enterData(sentence)
    def report(self,question):
        #report the data to the admin
        ReportData.enterData(question)
class adminBot:
    #built to use less memory and provide an interface with the main bot
    #responsible for teaching and managing
    def __init__(self,bot,database):
        self.bot=bot
        self.database=database
    def getToAdd(self):
        return self.database.readData()
    def add(self,question,answer):
        question=question.replace(":::","")
        
        if self.bot.lang.getType(question)!="question":
            file=open(self.bot.systemPathway+"sentenceDemos.txt","a")
            file.write(question+":::")
            file.close()
            self.bot.lang.Sample_Questions.append(question)
        if self.bot.Questions.getConnected(answer) !=[]: #cannot have same answer twice
            count=0
            while True: #loop testing out names
                if self.bot.Questions.getConnected(answer+"["+str(count)+"]") ==[]:
                    answer=answer+"["+str(count)+"]"
                    break
                count+=1
        v1=self.bot.lang.splitQuestion(question) #get nodes
        v1+=self.bot.lang.splitSubjects(question) #get nodes
        v1+=self.bot.lang.splitDirected(question) #get nodes
        for i in range(3): #add three times
            for i in v1:
                self.bot.Questions.addDirected(Edge(i,answer)) #add to graph
                self.bot.Questions.addDirected(Edge(answer,i)) #add to graph

        #SaveMemory(self.bot.systemPathway+"questions.json",self.bot.Questions.data) #save to file
        self.database.delete(question) #remove from database
    def addStatement(self,sentence):
        self.bot.Enter(sentence,[])
    def delete(self,question):
        self.database.delete(question) #remove from database
    def deleteQ(self,question):
        a=self.bot.Enter(question,[])
        r=self.bot.Questions.delete(a[0])
        if r!=None:
            f=r.copy()
            while f!=None:
                a=self.bot.Enter(question,[])
                f=self.bot.Questions.delete(a[0])
        return r #return first instance of deletion
    def getFeedback(self):
        return self.bot.Statements.readData()
    def readReport(self):
        return ReportData.readData()
    def addConfused(self,sentence):
        #add confused data
        self.bot.database.enterData(sentence)


class Log:
    def __init__(self,loc,name,language):
        if not os.path.exists(loc+"log"): #create log folder
                os.mkdir(loc+"log")
        if not os.path.exists(loc+"confused"): #create confused folder
                os.mkdir(loc+"confused")
        self.name=name
        self.path=loc
        self.convo=[]
        self.convoL=[]
        self.lang=language
        self.SAVE=True
    def add(self,data):
        if self.SAVE: #if save mode on
                file=open(self.path+"log/"+self.name,"a")
                file.write(">"+data)
                file.close()
                if len(self.convo)>15: #max of 15 sentences
                        del self.convo[0]
                        del self.convoL[0]
                self.convo.append(data)
                d=self.lang.splitDirected(data)
                s=self.lang.splitSubjects(data)
                m=self.lang.splitQuestion(data)
                self.convoL.append([d,s,m])
    def __str__(self):
        return self.name.replace(".txt","")
    def check(self,val):
            for (dirpath, dirnames, filenames) in os.walk(self.path+"confused/"):
                    f=filenames
                    for i in f:
                            file=open(self.path+"confused/"+i,"r")
                            r=file.read()
                            file.close()
                            if r==val:
                                    return False
            return True
    def sendToConfused(self):
            #send the log file to the to learn area
            file=open(self.path+"log/"+self.name,"r")
            r=file.read()
            file.close()
            if self.check(r):
                    if len(self.convo)<=1:
                            os.remove(self.path+"log/"+self.name)
                    file=open(self.path+"confused/"+self.name,"w")
                    file.write(r)
                    file.close()
    def readIn(self):
            #read in data
            temp=ConversationData(self.path+"log/")
            d=temp.openDataBase(self.name)
            start=0
            if len(d)-7>0:
                    start=len(d)-7
            for i in d[start:]: #add the data
                self.convo.append(d)
                d=self.lang.splitDirected(d)
                s=self.lang.splitSubjects(d)
                m=self.lang.splitQuestion(d)
                self.convoL.append([d,s,m])
class ConversationData:
    #store where the conversations are held and act as a reader
    def __init__(self,folder):
        self.folder=folder
    def openDataBase(self,name):
        filepath=self.folder+name+".txt"
        try: #checkk file exits
            file=open(filepath, "r")
            data=file.read()
            file.close()
            data=data.split(">")
            return data
        except:
                #future remove connections in list
                return []
class CB:
    #clever bot redesign
    def __init__(self,path):
        #for language classification
        self.LC=Bot("SHEP-classifier",path) #set up once in the memory
        self.LangC=Language(path)
        #Database pointer
        self.DBP=Graph(path+"link.json")
        self.CDB=ConversationData(path)
        #Hold current information
        self.path=path
        self.convo=Queue()
        uniqueName=str(datetime.datetime.now()).replace(" ","-").replace(".","-").replace(":","-") #works for one person
        self.priority=""
        self.currentLog=Log(path,uniqueName+".txt",self.LangC)
        self.convo=[]
    def getKEY(self,dt,s,m):
        probability,answer=self.LC.find(dt,s,m)
        KEY=""
        if probability >=0.8: #found
            KEY=answer
        elif probability >=0.65: #might have found
            KEY=answer
        else:
            #not found so add
            answer="C"+str(len(self.LC.Questions.data)) #make key unique
            v1=dt+s+m
            for i in range(3): #add three times for strong con
                for i in v1:
                    self.LC.Questions.addDirected(Edge(i,answer)) #add to graph
                    self.LC.Questions.addDirected(Edge(answer,i)) #add to graph
            KEY=answer
        return KEY
    def matchData(self,info,log):
        #match the information with the logFile and return the simularity
        #enter in log files as split language
        sumOfP=0
        for i in info:
                l=0
                for j in log:
                      p=self.LC.similar(i,j) #get probability
                      count=0
                      p=self.validateProb(p,i[1],j[1])
                      if p>0.8 and p>l:
                              l=p
                sumOfP+=l
        sumOfP=sumOfP/len(info)
        return sumOfP
    def validateProb(self,p,subs,subs2):
            count=0
            for subject in subs2: #count if all subjects present
                if subject in subs:
                    count+=1
            if count==len(subs2): #all subjects present
                p+=0.08
            else: #not all subjects are present
                p-=0.15
            return p
    def processCurrent(self,data,mess):
        #process the data in the current log
        current=self.CDB.openDataBase("log/"+str(self.currentLog))#only process up to the point
        indexTo=0
        information=self.LC.splitLanguage(mess)
        language=[]
        ifNoBreak=-1
        ifNoBreakP=0
        chance=0
        for i in data:
            vals=self.LC.splitLanguage(i)
            language.append(vals)
            d=vals[0]+vals[1]+vals[2]
            info=information[0]+information[1]+information[2]
            if len(d)<2:
                d=i.split()
            if len(info)<2:
                info=mess.split()
            p=self.LC.similar(d,info)
            p=self.validateProb(p,d,information[1])
            if p >=0.8: #found
                chance=p
                indexTo+=1
                break
            elif p >0.65: #might have found
                if p>ifNoBreakP:
                    chance=p
                    ifNoBreak=indexTo
            indexTo+=1
        if indexTo+1>=len(data) and ifNoBreak>0:
            indexTo=ifNoBreak
        elif indexTo+1>len(data):
            return "",0
        start=1
        if len(data[:indexTo+1])-15>0: #only analyse the last 100 words
               start=(indexTo+1)-15
        data=data[start:indexTo+1]
        response=""
        if len(data)>1:
                response=data[len(data)-1] #get the outcome
        if chance<0.5: #if no chance 
                return "",0 #break
        #work out simularity score with current convo
        matched=self.matchData(language,self.currentLog.convoL)
        simularity=(chance+matched)/(1+1)
        chance=simularity
        #work out
        return response,chance
    def getConfusedFile(self,message):
        #read throough confused files and find most similar
        #return data log object
        f=[]
        for (dirpath, dirnames, filenames) in os.walk(self.path+"confused/"):
            f=filenames
            break
        l=0
        log=None
        for i in filenames:
               data1=self.CDB.openDataBase("confused/"+i.replace(".txt",""))
               data,p=self.processCurrent(data1,message)
               if len(data)>0:
                       if data!="" and p>l and data1[-1]!=message:
                                log=Log(self.path,i,self.LangC)
                                l=p
        if log!=None:
                os.remove(self.path+"confused/"+log.name)
                return log
        return ""
    def readDatabases(self,databases,message):
        #read each database and rank the simularity of conversation
        potentials=[]
        S=[]
        for i in databases:
            data=self.CDB.openDataBase(i)
            #data==[]
            data,p=self.processCurrent(data,message)
            
            if data!="":
                potentials.append([data,p])
                S.append(i)
        potentials2=[]
        potentials3=[]
        if len(potentials)>0: #if found
            l=0
            v=""
            for i in potentials: #get largest
                if i[1]>l:
                    v=i[0]
                    l=i[1]
                if i[1]<l+0.15 and i[1]>l-0.15: #within bound
                        potentials2.append(i[0])
                if l>0.75: #really big chance
                    potentials3.append(i[0])
            if l<0.30 and len(self.currentLog.convo)>2: #if the probability is low then no longer save information to it
                    return ""
            if l>0.9: #if the conversation is really relevant
                print("*")
                c=0
                val=choice(potentials3) #return one of largest
                while c<len(potentials3)-1 and val in self.convo: #get one which has not been used
                    del potentials3[potentials3.index(val)] #remove
                    val=choice(potentials3) #return one of largest
                    c+=1
                return val
            print("~")
            c=0
            val=choice(potentials2) #return one of largest
            while c<len(potentials2)-1 and val in self.convo: #get one which has not been used
                del potentials2[potentials2.index(val)] #remove
                val=choice(potentials2) #return one of largest
                c+=1
            return val
        return ""
    def getRandom(self,type):
            #get a random phrase
            f=[]
            dates=[]
            for (dirpath, dirnames, filenames) in os.walk(self.path+type):
                    f=filenames
                    for i in f:
                        val=os.path.getctime(self.path+type+i)
                        dates.append(val)
                    break
            tmp=[]
            num=20
            if len(f)<20:
                num=len(f)
            for i in range(num): #get top 20
                item=max(dates)
                ind=dates.index(item)
                tmp.append(f[ind])
                del f[ind]
                del dates[ind]
            f=tmp.copy()
            data=[".."]
            val=self.convo[-1]
            count=0
            while val in self.convo and count<len(f): #try not repeat itself
                while len(data)<=1:
                                r=randrange(len(f)) #get out ofbounds
                                if r==len(f): #avoid out of bounds error
                                        r=r-1
                                i=f[r]
                                del f[r] #remove from choices
                                data=self.CDB.openDataBase(type+i.replace(".txt",""))
                                val=data[len(data)-1] #last position
                                
                count+=1
            return val
    def getShort(self,message):
            #get all short responses
            f=[]
            for (dirpath, dirnames, filenames) in os.walk(self.path+"confused/"):
                    f=filenames
                    for i in f:
                            data=self.CDB.openDataBase("confused/"+i.replace(".txt",""))
                            if len(data)==2 and data[1]!=message and data[1] not in self.convo:
                                    #delete file from log
                                    os.remove(self.path+"confused/"+i)
                                    return data[1]
                    break
            print("no short")
            return ""
    def setGetKey(self,message):
            dt,s,m=self.LC.splitLanguage(message)
            if len(dt+s+m)<2:
                    s=message.split()
            key=self.getKEY(dt,s,m) #get the key from the message
            return key
    def Enter(self,message):
        message=message.replace(">","").replace("\n","")
        self.currentLog.add(message) 
        key=self.setGetKey(message)
        #get the databases linked with the phrase
        ED=self.DBP.getConnected(key)
        databases=[]
        for i in ED:
            databases.append("log/"+i.vertices[1])
        #######for testing###############################################
        databases.append("testConvo")
        #############################################################
        outcome=self.readDatabases(databases,message)#find all posibile outcomes
        self.DBP.addDirected(Edge(key,str(self.currentLog))) #create link between data
        self.DBP.addDirected(Edge(str(self.currentLog),key)) #create link between data
        if outcome=="": #respond with same
            #gather message from
            Cfile=self.getConfusedFile(message)
            if Cfile!="":
                    #load into question queue and pick target
                    Cfile.readIn()
                    if len(Cfile.convo)>0:
                            self.currentLog=Cfile
                            return self.currentLog.convo[len(self.currentLog.convo)-1] #return last item
            self.currentLog.sendToConfused()
            uniqueName=str(datetime.datetime.now()).replace(" ","-").replace(".","-").replace(":","-") #works for one person
            self.currentLog=Log(self.path,uniqueName+".txt",self.LangC) #start again
            r=self.getRandom("confused/") #WILL RETURN RANDOM
            self.currentLog.add(r)
            print("&")
            return r
        else:
            self.currentLog.add(outcome)
            return outcome #return the found data
        #get the most
    def chat(self,message):
                self.convo.append(message)
                if len(self.convo)>15:
                        del self.convo[0]
                robotMessage=self.Enter(message)
                key=self.setGetKey(robotMessage) #set response as pointer
                self.DBP.addDirected(Edge(key,str(self.currentLog))) #create link between data
                self.DBP.addDirected(Edge(str(self.currentLog),key)) #create link between data
                self.convo.append(robotMessage)
                if len(self.convo)>15:
                        del self.convo[0]
                return robotMessage
    def train(self,array):
                #train in an array of conversation phrases
                count=0
                for message in array[:-1]:
                        key=self.setGetKey(message)
                        self.DBP.addDirected(Edge(key,str(self.currentLog))) #create link between data
                        self.currentLog.add(message)
                        self.currentLog.add(array[count+1])
                        count+=1
                        print("percentage:",str((count/len(array))*100),"%")

